#!/bin/sh
case "$1" in
start)

	echo "start LAN ..."			> /dev/console
	/etc/scripts/lan.sh start		> /dev/console
	echo "start WLAN ..."			> /dev/console
	/etc/scripts/wlan.sh start		> /dev/console
	echo "start DNSMASQ ..."		> /dev/console
	/etc/scripts/dnsmasq.sh start		> /dev/console
	echo "start NTPD ..."			> /dev/console
	/etc/scripts/ntpd.sh start		> /dev/console
	echo "start SSH ..."			> /dev/console
	/etc/scripts/dropbear.sh start		> /dev/console
	echo "start AVAHI ..."			> /dev/console
	/etc/scripts/avahi.sh start		> /dev/console
	;;
stop)
	echo "stop AVAHI ..."			> /dev/console
	/etc/scripts/avahi.sh stop		> /dev/console
	echo "stop SSH ..."			> /dev/console
	/etc/scripts/dropbear.sh stop		> /dev/console
	echo "stop NTPD ..."			> /dev/console
	/etc/scripts/ntpd.sh stop		> /dev/console
	echo "stop DNSMASQ ..."			> /dev/console
	/etc/scripts/dnsmasq.sh stop		> /dev/console
	echo "stop WLAN ..."			> /dev/console
	/etc/scripts/wlan.sh stop		> /dev/console

	echo "stop LAN ..."			> /dev/console
	/etc/scripts/lan.sh stop		> /dev/console
	;;
restart)
	sleep 3
	$0 stop
	$0 start
	;;
*)
	echo "Usage: system.sh {start|stop|restart}"
	;;
esac
exit 0
