<?php
include "include/shm.php";
$max_logical = db_read("/control/logical/max_actors");
$buttons = db_read_sql_solo("SELECT entry, value FROM frontend WHERE entry = 'artofbuttons'",1);
$actornames = db_read_sql_solo("SELECT entry, value FROM frontend WHERE entry = 'showactornames'",1);
$device=array('(ipad','(iphone', '(ipod');
$test=$_SERVER['HTTP_USER_AGENT'];
if(stripos($test, '(ipad')) {
   $icon_path="/img/icon_114/";
   $icon_width="150px";
   $icon_font="14px";
} else {
   $icon_path="/img/icon/";
   $icon_width="78px";
   $icon_font="10px";
}
if($max_logical>1){
   for ($i = 1;$i < $max_logical;$i++) {
	 if(db_read("/control/logical/actor" . $i. "/enabled")==1) {
	    $actor[db_read("/control/logical/actor" . $i. "/position")]=array("id" => $i, "check" => actor_shm_r_read_int($i), "name"=>db_read("/control/logical/actor" . $i. "/name"),"icon"=>db_read("/control/logical/actor" . $i. "/icon"), "enabled"=>db_read("/control/logical/actor" . $i. "/enabled"));
	 }
   }
   ksort($actor);
   #print_r($actor);
   foreach ($actor as &$i) {
	 if($i['enabled']==1) {
	    if($i['check']==1) {
		  $ac_on="1.png";
		  $ac_of=null;
	    } else {
		  $ac_on=null;
		  $ac_of="0.png";
	    }
	    $showname="<div>".substr($i['name'],0,12)."</div>";   
	 
	    if($i['check'] <= -204800000) {
		  $ac_on=null;
		  $ac_of=null;
		  $error="error.png"; ?>
		  <div style="float:left; width:<?php echo $icon_width; ?>; text-align:center; font-size:<?php echo $icon_font; ?>; font-weight:bold; margin-top:15px;">
			<img class="icon" id="<?php echo $i['id']; ?>" onoff="<?php echo $i['check']; ?>" icon="<?php echo $i['icon']; ?>" src="<?php echo $icon_path; ?>error.png" />
			<?php echo $showname; ?>
		  </div>   
   <?php } else { ?>
		  <div id="touch" style="float:left; width:<?php echo $icon_width; ?>; text-align:center; font-size:<?php echo $icon_font; ?>; font-weight:bold; margin-top:15px;">
			<img class="icon" id="<?php echo $i['id']; ?>" onoff="<?php echo $i['check']; ?>" icon="<?php echo $i['icon']; ?>" src="<?php echo $icon_path.$i['icon'].$ac_on.$ac_of; ?>" />
			<?php echo $showname; ?>
		  </div>
   <?php }
	 }
   }
}
?>
<script type="text/javascript">
function check_status() {
	var max_pl=<?php echo $max_logical; ?>;
	$.post("rw_actor.php", { rw: "3", max_powerline: max_pl },
		function(r) {
			$.each(r, function(key, val) {
				//alert(key + ' - ' + val.onoff);  
				if(val.onoff!='false') {
					if(val.onoff==0) {
						$('#'+key).attr('onoff', '0');
						var icon = $('#'+key).attr("icon");
						$('#'+key).attr("src", icon_path+icon+"0.png");
						//alert("0");
					}
					if(val.onoff==1) {
						$('#'+key).attr('onoff', '1');
						var icon = $('#'+key).attr("icon");
						$('#'+key).attr("src", icon_path+icon+"1.png");
						//alert("1");
					}
				} else {
					$('#'+key).attr("src", icon_path+"error.png");
					$('#'+key).attr('onoff', '-204800000');
					//$('#'+key).attr('icon', 'error.png');
				}
			})
		}, 'json' ); 
		 // setTimeout("check_status()",5000);
	}
</script>