/*
 s=slider
 r=red
 g=green
 b=blue

 d=dim
 l=light
 
 A=Kanal 0
 B=Kanal 1

 c=color
 w=whtie
 
 Beispiel:
 scgA = slider color green Kanal A
 slB = slider light Kanal B
 
*/

$(document).ready(function() {
      //$.post('rgb_set.php', { cmd: "10" } );
      $.post('rgb_set.php', { cmd: "12" }, function(prg) {
            if(prg.running_status==0) {
                  $('#runprogram').val(prg.loaded_program);
            } else {
                  $('#runprogram').val('nix');
            }
      },"json"); 
      $('#runprogram').change(function(){
            if(this.value=="-2") {
                  $.post('rgb_set.php', { cmd: "10" } );
                  message_rgb('messageprg');
                  $(this).val('nix');
            }
            if(this.value!="nix" && this.value!=-2) {
                $.post('rgb_set.php', { cmd: "11", wert: this.value } );  
            }
      })
      $.Shortcuts.add({ type: 'down', mask: '1', handler: function() { $("#swwAA").children("a").focus(); } });
      $.Shortcuts.add({ type: 'down', mask: '2', handler: function() { $("#scwAA").children("a").focus(); } });
      $.Shortcuts.add({ type: 'down', mask: '3', handler: function() { $("#swwBA").children("a").focus(); } });
      $.Shortcuts.add({ type: 'down', mask: '4', handler: function() { $("#scwBA").children("a").focus(); } });
      
      $.Shortcuts.add({ type: 'down', mask: 'Shift+r', handler: function() { $("#scrB").children("a").focus(); } });
      $.Shortcuts.add({ type: 'down', mask: 'Shift+g', handler: function() { $("#scgB").children("a").focus(); } });
      $.Shortcuts.add({ type: 'down', mask: 'Shift+b', handler: function() { $("#scbB").children("a").focus(); } });
      $.Shortcuts.add({ type: 'down', mask: 'Shift+w', handler: function() { $("#swB").children("a").focus(); } });
      
      $.Shortcuts.add({ type: 'down', mask: 'd', handler: function() { $("#sdA").children("a").focus(); } });
      $.Shortcuts.add({ type: 'down', mask: 'Shift+d', handler: function() { $("#sdB").children("a").focus(); } });
      
      $.Shortcuts.add({ type: 'down', mask: 'a', handler: function() { $("#slAA").children("a").focus(); } });
      $.Shortcuts.add({ type: 'down', mask: 'b', handler: function() { $("#slBA").children("a").focus(); } });
      $.Shortcuts.add({ type: 'down', mask: 'Shift+l', handler: function() { $("#slB").children("a").focus(); } });

      $.Shortcuts.add({ type: 'down', mask: 'o', handler: function() {
            $( "#f_wwAA,#f_cwAA,#f_wwBA,#f_cwBA,#f_rB,#f_gB,#f_bB,#f_wB,#f_dA,#f_dB,#f_lB,#f_lAA,#f_lBA" ).val('0');
            $( "#f_wwAA,#f_cwAA,#f_wwBA,#f_cwBA,#f_rB,#f_gB,#f_bB,#f_wB" ).css('background-color', '#000000' );
            $( "#f_wwAA,#f_cwAA,#f_wwBA,#f_cwBA,#f_rB,#f_gB,#f_bB,#f_wB" ).css('color', '#ffffff' );
            $( "#swwAA,#scwAA,#swwBA,#scwBA,#scrB,#scgB,#scbB,#swB,#sdA,#sdB,#slAA,#slBA,#slB" ).slider('value','0');
            set_light();
            set_values(0); 
      }
});
var cwheelB = $.farbtastic("#cwheelB");
cwheelB.linkTo(wheelUpdateB);
      $.Shortcuts.start();
      // COLOR SLIDER
      $("#scrB,#scgB,#scbB").slider( {
            min: 0,
            max: 255,
            animate: "slow",
            orientation: "vertical",
            slide: function( event, ui ) {
                  var channel=(this.id).substr(3);
                  var color=(this.id).substr(2,1);
                  var fg="rgb(255,255,255)";
                  if(color=="r"){ bg="rgb("+ui.value+",0,0)"; }
                  if(color=="g"){ bg="rgb(0,"+ui.value+",0)"; if(ui.value>170){ fg="rgb(0,0,0)"} else { fg="rgb(255,255,255)" } }
                  if(color=="b"){ bg="rgb(0,0,"+ui.value+")";}
                  $( "#f_"+color+channel).css("background-color", bg);
                  $( "#f_"+color+channel).css("color", fg);
                  if( $( "#f_"+color+channel).val()!=ui.value) {        
                        $( "#f_"+color+channel).val( ui.value );
                        set_light();
                        set_values(1);
                  }
            },
            stop: function( event, ui ) {
                  var id=this.id;
                  set_values(1);
            }
      });   
      
   // WHITE SLIDER
      $("#swB,#swwAA,#scwAA,#swwBA,#scwBA").slider( {
            min: 0,
            max: 255,
            animate: true,
            orientation: "vertical",
            slide: function( event, ui ) {
                  var channel=(this.id).substr(1);
                  if( $( "#f_"+channel).val()!=ui.value) {
                        var bg = "rgb("+ui.value+","+ui.value+","+ui.value+")";
                        if (ui.value<128) { var fg = "rgb(255,255,255)"; } else { fg = "rgb(0,0,0)"; };
                        
                        $( "#f_"+channel).val( ui.value );
                        $( "#f_"+channel).css('background-color', bg );
                        $( "#f_"+channel).css('color', fg );

                        set_light();
                        set_values(1);
                  }
            },
            stop: function( event, ui ) {
                  //var id=this.id;
                  set_values(1);
            }
      });      

      // DIM SLIDER
      $("#sdA,#sdB").slider( {
            min: 0,
            max: 255,
            animate: true,
            slide: function( event, ui ) {
                  var channel=(this.id).substr(1);
                  if( $( "#f_"+channel).val()!=ui.value) {
                        $( "#f_"+channel).val( ui.value );
                        set_values(1);
                  }
            },
            stop: function( event, ui ) {
                  var id=this.id;
                  set_values(1)
            }
      });
   
   // LIGHT SLIDER
      $("#slB,#slAA,#slBA").slider( {
            min: 0,
            max: 255,
            animate: true,
            slide: function( event, ui ) {
                  var val=ui.value;
                  var channel=(this.id).substr(1);
                  var AB=(this.id).substr(2);
                  if( $( "#f_"+channel).val()!=ui.value) {
                        $( "#f_"+channel).val( ui.value );
                        set_rgb(channel,AB,val);
                  }
            },
            stop: function( event, ui ) {
               var id=this.id;
               set_values(1);
            }
      });   


      $("#sdA").slider('value',$( "#f_dA" ).val());
      $("#sdB").slider('value',$( "#f_dB" ).val());
      $("#slB").slider('value',$( "#f_lB" ).val());
      $("#slAA").slider('value',$( "#f_lAA" ).val());
      $("#slBA").slider('value',$( "#f_lBA" ).val());
// INPUT LIGHT KEYPRESS     
      $('#f_lB,#f_lAA,#f_lBA').keyup(function() {
            var channel=(this.id).substr(2);
            var AB=(this.id).substr(3);
            var val=this.value;
            val=this.value;
            if(isNaN(val) ) {val=0}
               else if(val>255) { val=255 }
            this.value=val;
            $("#slB").slider('value',$( "#f_lB" ).val());
            $("#slAA").slider('value',$( "#f_lAA" ).val());
            $("#slBA").slider('value',$( "#f_lBA" ).val());
            set_rgb(channel,AB,val);
      })      
// INPUT KEYPRESS
      $('#f_wwAA,#f_cwAA,#f_wwBA,#f_cwBA,#f_dA,#f_dB,#f_rB,#f_gB,#f_bB,#f_wB').keyup(function() {
            val=this.value;
            if(isNaN(val) ) {val=0}
                  else if(val>255) { val=255 }
            this.value=val;
            if(val!="") {
                  backfor_color();
                  $("#sdA").slider('value',$( "#f_dA" ).val());
                  $("#sdB").slider('value',$( "#f_dB" ).val());
                  set_light();
                  set_values(1);
            }
      })    
      $('#f_wwAA,#f_cwAA,#f_wwBA,#f_cwBA,#f_rB,#f_gB,#f_bB,#f_wB,#f_dA,#f_dB,#f_lB,#f_lAA,#f_lBA').focusout(function() {
            val=this.value;
            if(val=="") {
                  this.value=0;
            }
            backfor_color();
      })
      $('#f_rA,#f_gA,#f_bA,#f_wA,#f_wwAB,#f_cwAB,#f_wwBB,#f_cwBB,#f_dA,#f_dB,#f_lA,#f_lAA,#f_lBA').focus(function() {
            this.select();
      })
      $( "#sync, #bootcolor" ).button();
      $( "#bootcolor" ).click( function() {
            set_values("1","set");
            message_rgb('messageboot');
      })
      $( "#sync" ).click( function() {
            var val=$("input[name='sync']:checked").val();
            b=($('#content').width()/2)-220;
            if(val=="true") {
                  $('#channelB').hide("slow");
                  //$('#channelA').css('float', 'none');
                  //$('#channelA').css('margin', '0 auto');
                  $('#channelA').animate({
                        'marginLeft' : "+="+b
                  });                 
                  $.post('rgb_set.php', { cmd: '1', wert: 'true'});
            } else {
                  //$('#channelA').css('margin', '0');
                  //$('#channelA').css('float', 'left');
                  $('#channelA').animate({
                        'marginLeft' : "0"
                  }); 
                  $('#channelB').show('slow');
                  $.post('rgb_set.php', { cmd: '1', wert: 'false'});
            }
            set_values(1)
            $('#scrA').children("a").focus();
      })
      backfor_color();
      set_light();

      function set_light() {
            window["hslB"]=rgbToHsl(($( "#f_rB" ).val()/255),($( "#f_gB" ).val()/255),($( "#f_bB" ).val()/255));
            $("#slB").slider('value',parseInt(window["hslB"][2]*255));
            $("#f_lB").val(parseInt(window["hslB"][2]*255));
            var wwAA=$( "#f_wwAA" ).val();
            var cwAA=$( "#f_cwAA" ).val();
            var wwBA=$( "#f_wwBA" ).val();
            var cwBA=$( "#f_cwBA" ).val();
            window["hslAA"]=rgbToHsl((wwAA/255),(cwAA/255),((wwAA/255)+(cwAA/255))/2);
            window["hslBA"]=rgbToHsl((wwBA/255),(cwBA/255),((wwBA/255)+(cwBA/255))/2);
            
            $("#slAA").slider('value',Math.round(window["hslAA"][2]*255));
            $("#slBA").slider('value',Math.round(window["hslBA"][2]*255));
            $("#f_lAA").val(Math.round(window["hslAA"][2]*255));
            $("#f_lBA").val(Math.round(window["hslBA"][2]*255));
            
            cwheelB.setColor(rgb2hex($( "#f_rB" ).val()+","+$( "#f_gB" ).val()+","+$( "#f_bB" ).val()));
      }
      function set_rgb(channel, AB, val) {
            var rgb=hslToRgb(window["hsl"+AB][0],window["hsl"+AB][1],(val/255));
         
            $("#scr"+AB).slider('value',Math.round(rgb[0]*255));
            $("#scg"+AB).slider('value',Math.round(rgb[1]*255));
            $("#scb"+AB).slider('value',Math.round(rgb[2]*255));
            $( "#f_r"+AB ).val(Math.round(rgb[0]*255));
            $( "#f_g"+AB ).val(Math.round(rgb[1]*255));
            $( "#f_b"+AB ).val(Math.round(rgb[2]*255));
            
            $("#sww"+AB).slider('value',Math.round(rgb[0]*255));
            $("#scw"+AB).slider('value',Math.round(rgb[1]*255));
      
            $( "#f_ww"+AB ).val(Math.round(rgb[0]*255));
            $( "#f_cw"+AB ).val(Math.round(rgb[1]*255));
            
            cwheelB.setColor(rgb2hex($( "#f_rB" ).val()+","+$( "#f_gB" ).val()+","+$( "#f_bB" ).val())); 
            backfor_color();
            set_values(1);
      }      
 
      function backfor_color() {
         var arr= Array('rB','gB','bB','wB','wwAA','cwAA','wwBA','cwBA');
         $.each(arr, function(index, key) {      
            var val = $( "#f_"+key ).val();
            var fg="rgb(255,255,255)";
            var ch=key.slice(-1);
            if(ch!="A") {
               if(key.substr(0,1)!="w") {
                  if(key.substr(0,1)=="r"){ bg="rgb("+val+",0,0)";}
                  if(key.substr(0,1)=="g"){ bg="rgb(0,"+val+",0)"; if(val>170){ fg="rgb(0,0,0)"} else { fg="rgb(255,255,255)" }}
                  if(key.substr(0,1)=="b"){ bg="rgb(0,0,"+val+")";}
                  $("#sc"+key).slider('value',$( "#f_"+key ).val());
                  $( "#f_"+key).css("background-color", bg);
                  $( "#f_"+key).css("color", fg);
               } else {
                  if(key.substr(0,1)=="w"){ bg="rgb("+val+","+val+","+val+")"; if(val>128){ fg="rgb(0,0,0)"} else { fg="rgb(255,255,255)" }}   
                  $("#s"+key).slider('value',$( "#f_"+key ).val());
                  $( "#f_"+key).css("background-color", bg);
                  $( "#f_"+key).css("color", fg);
               }
            } else {
               var bg="rgb("+val+","+val+","+val+")";
               if(val>128) {
                     var fg="rgb(0,0,0)";
               }
               $("#s"+key).slider('value',$( "#f_"+key ).val());
               $( "#f_"+key).css("background-color", bg);
               $( "#f_"+key).css("color", fg);
            }
         });
      }
      
      function wheelUpdateB(color){     
            $("#swatch").css("background-color",color);
            if(cwheelB.hsl[2]>0.5){      
                  $("#innerswatch").css("color","#000000");     
            } else {
                  $("#innerswatch").css("color","#ffffff");
            }
            
            $("#innerswatch").html(color.toUpperCase())
            var red = parseInt(color.substring(1,3),16);
            var green = parseInt(color.substring(3,5),16);
            var blue = parseInt(color.substring(5,7),16);	
      
            $("#f_rB").val(red);
            $("#f_gB").val(green);
            $("#f_bB").val(blue);
            $("#scrB").slider("value",red);
            $("#scgB").slider("value",green);
            $("#scbB").slider("value",blue);
            set_light();
            backfor_color()
            set_values(1);
      }
});

function set_values(fc,set) {
      $("#sdA").slider('value',$( "#f_dA" ).val());
      $("#sdB").slider('value',$( "#f_dB" ).val());
      var valchB=$( "#f_rB" ).val()+","+$( "#f_gB" ).val()+","+$( "#f_bB" ).val();
      var valchA =$("#f_wwAA" ).val()+","+$( "#f_cwAA" ).val()+","+$( "#f_wwBA" ).val();
      var valwchA=$("#f_cwBA" ).val();
      var valdimA=$( "#f_dA" ).val();
      var valdimB=$( "#f_dB" ).val();
      var valwchB=$( "#f_wB" ).val();
      var rgbi2c="c_fc="+fc+"&c_rgbA="+valchA+"&c_rgbB="+valchB+"&c_w0="+valwchA+"&c_w1="+valwchB+"&c_d0="+valdimA+"&c_d1="+valdimB;     
      xhr = $.ajax({
            type: 'POST',
            url: 'rgb_live.php',
            data: rgbi2c,
            async: false
      });
      if(set != undefined) { // BOOTCOLOR 
            rgbi2c=rgbi2c+"&cmd=2";
            xhr = $.ajax({
                  type: 'POST',
                  url: 'rgb_set.php',
                  data: rgbi2c,
                  async: false
            });
      }
}
function message_rgb(msg) {
      $.blockUI({
            message: $('div.'+msg),
            fadeIn: 700, 
            fadeOut: 700, 
            timeout: 2000,
            showOverlay: false, 
            css: {	
                 border: 'none', 
                 padding: '15px', 
                 backgroundColor: '#000', 
                 '-webkit-border-radius': '10px', 
                 '-moz-border-radius': '10px',
                 'border-radius': '10px', 
                 opacity: .6, 
                 color: '#fff'
            }
      });
}