/*
 s=slider
 ww=WarmWhite
 cw=ColdWhite
 AA=Ausgang A Kanal 0
 AA=Ausgang B Kanal 0
 AB=Ausgang A Kanal 1
 BB=Ausgang B Kanal 1
 d=dim
 l=light
 
 A=Kanal 0
 B=Kanal 1
 
 Beispiel:
 swwAB = slider WarmWhite Ausgang A Kanal 0
*/

$(document).ready(function() {
      //$.post('rgb_set.php', { cmd: "10" } );
      $.post('rgb_set.php', { cmd: "12" }, function(prg) {
            if(prg.running_status==0) {
                  $('#runprogram').val(prg.loaded_program);
            } else {
                  $('#runprogram').val('nix');
            }
            },"json"); 
            $('#runprogram').change(function(){
                  if(this.value=="-2") {
                        $.post('rgb_set.php', { cmd: "10" } );
                        message_rgb('messageprg');
                        $(this).val('nix');
                  }
                  if(this.value!="nix" && this.value!=-2) {
                      $.post('rgb_set.php', { cmd: "11", wert: this.value } );  
                  }
      })
      $.Shortcuts.add({ type: 'down', mask: '1', handler: function() { $("#swwAA").children("a").focus(); } });
      $.Shortcuts.add({ type: 'down', mask: '2', handler: function() { $("#scwAA").children("a").focus(); } });
      $.Shortcuts.add({ type: 'down', mask: '3', handler: function() { $("#swwBA").children("a").focus(); } });
      $.Shortcuts.add({ type: 'down', mask: '4', handler: function() { $("#scwBA").children("a").focus(); } });
      
      $.Shortcuts.add({ type: 'down', mask: 'Shift+1', handler: function() { $("#swwAB").children("a").focus(); } });
      $.Shortcuts.add({ type: 'down', mask: 'Shift+2', handler: function() { $("#scwAB").children("a").focus(); } });
      $.Shortcuts.add({ type: 'down', mask: 'Shift+3', handler: function() { $("#swwBB").children("a").focus(); } });
      $.Shortcuts.add({ type: 'down', mask: 'Shift+4', handler: function() { $("#scwBB").children("a").focus(); } });
      
      $.Shortcuts.add({ type: 'down', mask: 'd', handler: function() { $("#sdA").children("a").focus(); } });
      $.Shortcuts.add({ type: 'down', mask: 'Shift+d', handler: function() { $("#sdB").children("a").focus(); } });
      
      $.Shortcuts.add({ type: 'down', mask: 'a', handler: function() { $("#slAA").children("a").focus(); } });
      $.Shortcuts.add({ type: 'down', mask: 'b', handler: function() { $("#slBA").children("a").focus(); } });
      $.Shortcuts.add({ type: 'down', mask: 'Shift+a', handler: function() { $("#slAB").children("a").focus(); } });
      $.Shortcuts.add({ type: 'down', mask: 'Shift+b', handler: function() { $("#slBB").children("a").focus(); } });
      
      $.Shortcuts.add({ type: 'down', mask: 'o', handler: function() {
            $( "#f_wwAA,#f_cwAA,#f_wwBA,#f_cwBA,#f_wwAB,#f_cwAB,#f_wwBB,#f_cwBB,#f_dA,#f_dB,#f_lAA,#f_lBA,#f_lAB,#f_lBB" ).val('0');
            $( "#f_wwAA,#f_cwAA,#f_wwBA,#f_cwBA,#f_wwAB,#f_cwAB,#f_wwBB,#f_cwBB" ).css('background-color', '#000000' );
            $( "#f_wwAA,#f_cwAA,#f_wwBA,#f_cwBA,#f_wwAB,#f_cwAB,#f_wwBB,#f_cwBB" ).css('color', '#ffffff' );
            $( "#swwAA,#scwAA,#swwBA,#scwBA,#swwAB,#scwAB,#swwBB,#scwBB,#swwAA,#scwAB,#swwAB,#scwBB,#slAA,#slBA,#slAB,#slBA" ).slider('value','0');
            set_light();
            set_values(0);
         }
      });
      $.Shortcuts.start();
// WHITE SLIDER
      $("#swwAA,#scwAA,#swwBA,#scwBA,#swwAB,#scwAB,#swwBB,#scwBB").slider( {
            min: 0,
            max: 255,
            animate: true,
            orientation: "vertical",
            slide: function( event, ui ) {
                  var channel=(this.id).substr(1);
                  if( $( "#f_"+channel).val()!=ui.value) {
                        var bg = "rgb("+ui.value+","+ui.value+","+ui.value+")";
                        if (ui.value<128) { var fg = "rgb(255,255,255)"; } else { fg = "rgb(0,0,0)"; };
                        
                        $( "#f_"+channel).val( ui.value );
                        $( "#f_"+channel).css('background-color', bg );
                        $( "#f_"+channel).css('color', fg );

                        set_light();
                        set_values(1);
                  }
            },
            stop: function( event, ui ) {
                  //var id=this.id;
                  set_values(1);
            }
      });
   
   // DIM SLIDER
      $("#sdA,#sdB").slider( {
            min: 0,
            max: 255,
            animate: true,
            slide: function( event, ui ) {
                  var channel=(this.id).substr(1);
                  if( $( "#f_"+channel).val()!=ui.value) {
                        $( "#f_"+channel).val( ui.value );
                        set_values(1);
                  }
            },
            stop: function( event, ui ) {
                  var id=this.id;
                  set_values(1);
             }
      });
   
   // LIGHT SLIDER
      $("#slAA,#slBA,#slAB,#slBB").slider( {
            min: 0,
            max: 255,
            animate: true,
            slide: function( event, ui ) {
                  var val=ui.value;
                  var channel=(this.id).substr(1);
                  var AB=(this.id).substr(2);
                  if( $( "#f_"+channel).val()!=ui.value) {
                        $( "#f_"+channel).val( ui.value );
                        set_rgb(channel,AB,val);
                  }
            },
            stop: function( event, ui ) {
                  var id=this.id;
                  set_values(1);
            }
      });   

      
      $("#sdA").slider('value',$( "#f_dA" ).val());
      $("#sdB").slider('value',$( "#f_dB" ).val());
      $("#slAA").slider('value',$( "#f_lAA" ).val());
      $("#slBA").slider('value',$( "#f_lBA" ).val());
      $("#slAB").slider('value',$( "#f_lAB" ).val());
      $("#slBB").slider('value',$( "#f_lBB" ).val());
// INPUT LIGHT KEYPRESS
      $('#f_lAA,#f_lBA,#f_lAB,#f_lBB').keyup(function() {
            var channel=(this.id).substr(2);
            var AB=(this.id).substr(3);
            var val=this.value;
            val=this.value;
            if(isNaN(val) ) {val=0}
               else if(val>255) { val=255 }
            this.value=val;
            $("#slAA").slider('value',$( "#f_lAA" ).val());
            $("#slBA").slider('value',$( "#f_lBA" ).val());
            $("#slAB").slider('value',$( "#f_lAB" ).val());
            $("#slBB").slider('value',$( "#f_lBB" ).val());
            set_rgb(channel,AB,val);
      })
// INPUT KEYPRESS
      $('#f_wwAA,#f_cwAA,#f_wwBA,#f_cwBA,#f_wwAB,#f_cwAB,#f_wwBB,#f_cwBB,#f_dA,#f_dB').keyup(function() {
            val=this.value;
            if(isNaN(val) ) {val=0}
               else if(val>255) { val=255 }
            this.value=val;
            if(val!="") {
               backfor_color();
               $("#sdA").slider('value',$( "#f_dA" ).val());
               $("#sdB").slider('value',$( "#f_dB" ).val());
               set_light();
               set_values(1);
            }
      })
      $('#f_wwAA,#f_cwAA,#f_wwBA,#f_cwBA,#f_wwAB,#f_cwAB,#f_wwBB,#f_cwBB,#f_dA,#f_dB,#f_lAA,#f_lBA,#f_lAB,#f_lBB').focusout(function() {
            val=this.value;
            if(val=="") {
               this.value=0;
            }
            backfor_color();
      })
      $('#f_wwAA,#f_cwAA,#f_wwBA,#f_cwBA,#f_wwAB,#f_cwAB,#f_wwBB,#f_cwBB,#f_dA,#f_dB,#f_lAA,#f_lBA,#f_lAB,#f_lBB').focus(function() {
            this.select();
      })
      $( "#sync, #bootcolor" ).button();
      $( "#bootcolor" ).click( function() {
            set_values("1","set");
            message_rgb('messageboot');
      })
      $( "#sync" ).click( function() {
            var val=$("input[name='sync']:checked").val();
            b=($('#content').width()/2)-220;
            if(val=="true") {
                  $('#channelB').hide("slow");
                  //$('#channelA').css('float', 'none');
                  //$('#channelA').css('margin', '0 auto');
                  $('#channelA').animate({
                        'marginLeft' : "+="+b
                  });
                  $.post('rgb_set.php', { cmd: '1', wert: 'true'});
            } else {
                  //$('#channelA').css('margin', '0');
                  //$('#channelA').css('float', 'left');
                  $('#channelA').animate({
                        'marginLeft' : "0"
                  }); 
                  $('#channelB').show("slow");
                  $.post('rgb_set.php', { cmd: '1', wert: 'false'});
            }
            set_values(1)
            $('#swwAA').children("a").focus();
      })
      backfor_color();
      set_light();

      function set_light() {
            var wwAA=$( "#f_wwAA" ).val();
            var cwAA=$( "#f_cwAA" ).val();
            var wwBA=$( "#f_wwBA" ).val();
            var cwBA=$( "#f_cwBA" ).val();
            var wwAB=$( "#f_wwAB" ).val();
            var cwAB=$( "#f_cwAB" ).val();
            var wwBB=$( "#f_wwBB" ).val();
            var cwBB=$( "#f_cwBB" ).val();
            window["hslAA"]=rgbToHsl((wwAA/255),(cwAA/255),((wwAA/255)+(cwAA/255))/2);
            window["hslBA"]=rgbToHsl((wwBA/255),(cwBA/255),((wwBA/255)+(cwBA/255))/2);
            window["hslAB"]=rgbToHsl((wwAB/255),(cwAB/255),((wwAB/255)+(cwAB/255))/2);
            window["hslBB"]=rgbToHsl((wwBB/255),(cwBB/255),((wwBB/255)+(cwBB/255))/2);

            $("#slAA").slider('value',Math.round(window["hslAA"][2]*255));
            $("#slBA").slider('value',Math.round(window["hslBA"][2]*255));
            
            $("#slAB").slider('value',Math.round(window["hslAB"][2]*255));
            $("#slBB").slider('value',Math.round(window["hslBB"][2]*255));
            
            $("#f_lAA").val(Math.round(window["hslAA"][2]*255));
            $("#f_lBA").val(Math.round(window["hslBA"][2]*255));
            $("#f_lAB").val(Math.round(window["hslAB"][2]*255));
            $("#f_lBB").val(Math.round(window["hslBB"][2]*255));
      }
      function set_rgb(channel, AB, val) {
            var rgb=hslToRgb(window["hsl"+AB][0],window["hsl"+AB][1],(val/255));
         
            $("#sww"+AB).slider('value',Math.round(rgb[0]*255));
            $("#scw"+AB).slider('value',Math.round(rgb[1]*255));
      
            $( "#f_ww"+AB ).val(Math.round(rgb[0]*255));
            $( "#f_cw"+AB ).val(Math.round(rgb[1]*255));
            
            backfor_color();           
            set_values(1);

      }
      function backfor_color() {
            var arr= Array('wwAA','cwAA','wwBA','cwBA','wwAB','cwAB','wwBB','cwBB');
            $.each(arr, function(index, key) {
                  var val = $( "#f_"+key ).val();
                  var fg="rgb(255,255,255)";
                  var bg="rgb("+val+","+val+","+val+")";
                  if(val>128) {
                        var fg="rgb(0,0,0)";
                  }
                  $("#s"+key).slider('value',$( "#f_"+key ).val());
                  $( "#f_"+key).css("background-color", bg);
                  $( "#f_"+key).css("color", fg);
            });
      }
});

function set_values(fc,set) {
      var sync=$("input[name='sync']:checked").val();
      if(sync=="true") {
           var valchA=$("#f_wwAA").val()+","+$("#f_cwAA").val()+","+$("#f_wwBA").val();
           var valwchA=$("#f_cwBA").val();
           var valdimA=$("#f_dA").val();
           $("#f_wwAB").val($( "#f_wwAA" ).val());
           $("#f_cwAB").val($( "#f_cwAA" ).val());
           $("#f_wwBB").val($( "#f_wwBA" ).val());
           $("#f_cwBB").val($( "#f_cwBA" ).val());
           $("#f_dB").val(valdimA);
           rgbi2c="c_fc="+fc+"&c_rgbA="+valchA+"&c_rgbB="+valchA+"&c_w0="+valwchA+"&c_w1="+valwchA+"&c_d0="+valdimA+"&c_d1="+valdimA;
      } else {
            var valchA =$("#f_wwAA" ).val()+","+$( "#f_cwAA" ).val()+","+$( "#f_wwBA" ).val();
            var valwchA=$("#f_cwBA" ).val();            
            var valchB =$("#f_wwAB" ).val()+","+$( "#f_cwAB" ).val()+","+$( "#f_wwBB" ).val();
            var valwchB=$("#f_cwBB" ).val();
            var valdimA=$("#f_dA" ).val();
            var valdimB=$("#f_dB" ).val();
            var rgbi2c="c_fc="+fc+"&c_rgbA="+valchA+"&c_rgbB="+valchB+"&c_w0="+valwchA+"&c_w1="+valwchB+"&c_d0="+valdimA+"&c_d1="+valdimB;
      }
      xhr = $.ajax({
                  type: 'POST',
                  url: 'rgb_live.php',
                  data: rgbi2c,
                  async: false
            });
      if(set != undefined) { // BOOTCOLOR 
            rgbi2c=rgbi2c+"&cmd=2";
            xhr = $.ajax({
                  type: 'POST',
                  url: 'rgb_set.php',
                  data: rgbi2c,
                  async: false
            });
      }            
      
      
      
      /*
      alert(channel.slice(-1));
      alert((this.id).substr(0,this.id.length-1)+"B");
      if(x==true) {
            test= (this.id).substr(0,this.id.length-1)+"B";
            var channel=(test).substr(1);
            var AB=(test).substr(2);
            $( "#f_"+channel).val( ui.value );
            set_rgb(channel,AB,val)
      }*/
}
function message_rgb(msg) {
      $.blockUI({
            message: $('div.'+msg),
            fadeIn: 700, 
            fadeOut: 700, 
            timeout: 2000,
            showOverlay: false, 
            css: {	
                 border: 'none', 
                 padding: '15px', 
                 backgroundColor: '#000', 
                 '-webkit-border-radius': '10px', 
                 '-moz-border-radius': '10px',
                 'border-radius': '10px', 
                 opacity: .6, 
                 color: '#fff'
            }
      });
}