// **********   powerline_demon.h - Include-File fr den Powerline-Demon   **********


// #include "../strdb/strdb.h"

// *****   Globale Variablen   ******

#define											POWERLINE_DEMON_VERSION "1.90"
#define											POWERLINE_MAX_SLAVES 128
extern unsigned short int		cache_max_slaves;
extern signed char					cache_slave_enabled[POWERLINE_MAX_SLAVES];
extern signed char					cache_slave_use_buttons[POWERLINE_MAX_SLAVES];
extern signed char					cache_slave_typ[POWERLINE_MAX_SLAVES];
extern char									cache_slave_lon_id[POWERLINE_MAX_SLAVES][13];
extern signed long int			cache_slave_mapfrom_actor[POWERLINE_MAX_SLAVES][8];
extern signed long int			cache_slave_value[POWERLINE_MAX_SLAVES][8];
extern char									cache_slave_name[POWERLINE_MAX_SLAVES][80];
extern char									cache_slave_comment[POWERLINE_MAX_SLAVES][80];
extern signed long int			powerline_reload_counter;
extern signed long int			powerline_baudrate;
extern char									powerline_comport[150];
extern signed long int			read_delay;
extern signed long int			powerline_max_retries;
extern signed long int			powerline_modus;
extern signed long int			powerline_listen_to_broadcasts;
extern int									shID;
extern struct s_shm_actordata*	shm_actor_r_data;
extern struct s_shm_actordata*	shm_actor_w_data;
extern int									global_fd;
extern char									servicepin_slave_lon_id[13];



// *****   Funktions-Prototypen   *****

signed short int	actor_add(char name[],char bla[],signed short int enabled,signed short int typ,signed short int bootdefault,signed short int einaus_sensor,signed short int watt_sensor);
void							actor_show(signed short int nummer);
void							actor_increase_counter(void);
void							cache_setzedefault(void);
unsigned short int cache_slave_load(unsigned short int t);
void							cache_slave_save(unsigned short int t);
void							pldemon_readconfig(void);
signed long int		powerline_query(unsigned short int dosennummer,unsigned short int kanal,int fd);
signed long int		powerline_query2(unsigned short int dosennummer,unsigned short int kanal,unsigned short int tries,int fd);
signed long int		powerline_query_buttonflag(unsigned short int dosennummer,unsigned short int kanal,int fd);
signed long int		powerline_query_buttonflag2(unsigned short int dosennummer,unsigned short int kanal,unsigned short int tries,int fd);
signed long int 	powerline_query_devicetyp(char dosenid[],int fd);
signed long int		powerline_query_devicetyp2(char dosenid[],unsigned short int tries,int fd);
signed long int		powerline_query_servicepin(int fd);
signed long int		powerline_query_servicepin2(unsigned short int tries,int fd);
signed long int		powerline_schalte(unsigned short int dosennummer,unsigned short int kanal,unsigned short int schaltwunsch,int fd);
signed long int		powerline_schalte2(unsigned short int dosennummer,unsigned short int kanal,unsigned short int schaltwunsch,unsigned short int tries,int fd);
int								rs232_open(char device[],unsigned long int baudrate);
long							get_ms_now(void);
