// **********   powermeter_timer.h - Include-File fr den Powermeter-Timer   **********


// #include "../strdb/strdb.h"

// *****   Globale Variablen   ******

#define											MAX_TIMERS 128
#define											TIMER_GRACE_PERIOD 3

extern signed long int			timer_reload_counter;
extern signed long int			timer_max_timers;																							// Anzahl tatschlich benutzter Timer
extern signed long int			timer_reload_counter;																					// Reload Counter
extern signed char					timer_enabled[MAX_TIMERS];																		// Timer Enabled 0/1
extern char									timer_name[MAX_TIMERS][40];																		// Timer Benennung
extern signed char					timer_start_monday[MAX_TIMERS];																// Schaltzeitpunkt Wochentag
extern signed char					timer_start_tuesday[MAX_TIMERS];															// Schaltzeitpunkt Wochentag
extern signed char					timer_start_wednesday[MAX_TIMERS];														// Schaltzeitpunkt Wochentag
extern signed char					timer_start_thursday[MAX_TIMERS];															// Schaltzeitpunkt Wochentag
extern signed char					timer_start_friday[MAX_TIMERS];																// Schaltzeitpunkt Wochentag
extern signed char					timer_start_saturday[MAX_TIMERS];															// Schaltzeitpunkt Wochentag
extern signed char					timer_start_sunday[MAX_TIMERS];																// Schaltzeitpunkt Wochentag
extern signed char					timer_start_hour[MAX_TIMERS];																	// Uhrzeit Stunde
extern signed char					timer_start_minute[MAX_TIMERS];																// Uhrzeit Minute
extern signed char					timer_start_second[MAX_TIMERS];																// Uhrzeit Sekunde
extern signed short int			timer_start_onoff[MAX_TIMERS];																// On/Off 0/1
extern signed short int			timer_start_actor[MAX_TIMERS];																// On/Off 0/1
extern signed char					timer_stop_monday[MAX_TIMERS];																// Schaltzeitpunkt Wochentag
extern signed char					timer_stop_tuesday[MAX_TIMERS];																// Schaltzeitpunkt Wochentag
extern signed char					timer_stop_wednesday[MAX_TIMERS];															// Schaltzeitpunkt Wochentag
extern signed char					timer_stop_thursday[MAX_TIMERS];															// Schaltzeitpunkt Wochentag
extern signed char					timer_stop_friday[MAX_TIMERS];																// Schaltzeitpunkt Wochentag
extern signed char					timer_stop_saturday[MAX_TIMERS];															// Schaltzeitpunkt Wochentag
extern signed char					timer_stop_sunday[MAX_TIMERS];																// Schaltzeitpunkt Wochentag
extern signed char					timer_stop_hour[MAX_TIMERS];																	// Uhrzeit Stunde
extern signed char					timer_stop_minute[MAX_TIMERS];																// Uhrzeit Minute
extern signed char					timer_stop_second[MAX_TIMERS];																// Uhrzeit Sekunde
extern signed short int			timer_stop_onoff[MAX_TIMERS];																	// On/Off 0/1
extern signed short int			timer_stop_actor[MAX_TIMERS];																	// On/Off 0/1
extern signed short int			timer_count;																									// Anzahl enabled Timers



// *****   Funktions-Prototypen   *****

void								all3075_schalte_egal												(unsigned short int dosennummer,unsigned short int schaltwunsch);
void								plugwise_schalte_egal												(unsigned short int dosennummer,unsigned short int schaltwunsch);
void								timer_setzedefault													(void);
void								timer_readconfig														(void);
void								timer_execute																(void);
