// **********   sensor_history.h - History lesen, schreiben und updaten   **********



// **********   Globale Variablen   **********

#define								MAX_HISTORY 512

char									history_savefile[80] = "/etc/allnetenv/sensorhistory.dat";
char									history_xmlfile[80] = "/www/reports/history.xml";
char									history_tmpfile[80] = "/tmp/history.tmp";
char									svg_tmpfile[80] = "/tmp/svg.tmp";
float									history_array[MAX_LOGICAL_SENSORS][MAX_HISTORY];							// Sensor-History
unsigned long int			last_history = 0;																							// Timestamp der letzten History
unsigned long int			next_history = 0;																							// Timestamp der nchsten History


// *****   Funktions-Prototypen   *****

void								history_setzedefault												(void);
void								history_shift																(void);
void								history_update															(void);
void								history_read_data														(void);
void								history_write_data													(void);
void								history_write_svg														(signed char all_true);
void								history_write_xml														(void);
