// *********************************************************************************************************************
// *********************************************************************************************************************
// **                                                                                                                 **
// **   xml_edit.h   -   Tags aus XML-Dateien auslesen und diese auch hineinschreiben                                 **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** (C) 2009 - 2011 by Allnet Deutschland GmbH (www.allnet.de)                                                      **
// **                    Michael Buchstaller     (buchi@allnet.de)                                                    **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** This program is free software: you can redistribute it and/or modify                                            **
// ** it under the terms of the GNU General Public License as published by                                            **
// ** the Free Software Foundation, either version 3 of the License, or                                               **
// ** (at your option) any later version.                                                                             **
// **                                                                                                                 **
// ** This program is distributed in the hope that it will be useful,                                                 **
// ** but WITHOUT ANY WARRANTY; without even the implied warranty of                                                  **
// ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                                   **
// ** GNU General Public License for more details.                                                                    **
// **                                                                                                                 **
// ** You should have received a copy of the GNU General Public License                                               **
// ** along with this program.  If not, see http://www.gnu.org/licenses                                               **
// **                                                                                                                 **
// *********************************************************************************************************************
// *********************************************************************************************************************


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <termios.h>
#include <unistd.h>



#define XML_MAX_MEMSIZE 256000
extern signed short int		iteration_depth;



// **********   Funktions-Prototypen   *****

signed long int						readfileinstring							(char filename[],char *stringposition);
signed long int						parse_xml											(char xml[],char feldname[],char *stringposition);
signed long int						parse_xml_recursive						(char xml[],char feldname[],char *stringposition);
signed long int						read_xml											(char xml_filename[],char section_and_tagname[],char *stringposition);
signed long int						write_xml											(char xml_filename[],char section_and_tagname[],char daten[]);

double										lese_xml_float								(char xml[],char section_and_tagname[],double fdefault);
signed long int						lese_xml_int									(char xml[],char section_and_tagname[],signed long int idefault);
void											lese_xml_string								(char xml[],char section_and_tagname[],char *stringposition,char sdefault[]);
void											schreibe_xml_string						(char xml_filename[],char section_and_tagname[],char datenstring[]);
void											schreibe_xml_int							(char xml_filename[],char section_and_tagname[],signed long int datenint);
void											schreibe_xml_float						(char xml_filename[],char section_and_tagname[],double datenfloat);
