#!/bin/sh
case "$1" in
start)

	echo "start LAN ..."			> /dev/console
	/etc/scripts/lan.sh start		> /dev/console
	echo "start WLAN ..."			> /dev/console
	/etc/scripts/wlan.sh start		> /dev/console
	echo "start DHCP ..."			> /dev/console
	/etc/scripts/udhcpc.sh start		> /dev/console
	;;
stop)
	echo "stop DHCP ..."			> /dev/console
	/etc/scripts/udhcpc.sh stop		> /dev/console
	echo "stop WLAN ..."			> /dev/console
	/etc/scripts/wlan.sh stop		> /dev/console
	echo "stop LAN ..."			> /dev/console
	/etc/scripts/lan.sh stop		> /dev/console
	;;
restart)
	sleep 3
	$0 stop
	$0 start
	;;
*)
	echo "Usage: networking.sh {start|stop|restart}"
	;;
esac
exit 0
