<!DOCTYPE HTML>
<html xmlns=http://www.w3.org/1999/xhtml>
   <head>
      <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<script type="text/javascript" src="../script/jquery-min.js"></script>
<script type="text/javascript" src="../script/jquery-ui-min.js"></script>
<link rel="stylesheet" type="text/css" href="../css/jquery-ui.css" />
<style type="text/css">
body {background-color: #ffffff; color: #000000;}
body, td, th, h1, h2 {font-family: sans-serif;}
pre {margin: 0px; font-family: monospace;}
table {border-collapse: collapse;}
.center {text-align: center;}
.center table { margin-left: auto; margin-right: auto; text-align: left;}
.center th { text-align: center !important; }
td, th { border: 1px solid #000000; font-size: 100%; font-weight:bold; vertical-align: baseline;}
h1 {font-size: 150%;}
h2 {font-size: 125%;}
.p {text-align: left;}
</style>
<script type="text/javascript">
	$(function() {
<?php	if(!detect_ie()) { ?>
		$('tr').dblclick(function() { 
			get_values(this.id.substring(2));
		});
<?php } ?>
		$('tr').mouseover(function() { 
			window['color'] = $(this).css("background-color");
			$(this).css({backgroundColor: '#ffe' })
		});
		
		$('tr').mouseout(function() { 
			$(this).css({backgroundColor: window['color']  })
		});
		
		$('#unew').click(function() { 
			dialog_new();
		});
		
		$('#udel').click(function() { 
			dialog_del();
		});
		
		$('span').click(function() {
			delete_value(this.id);
		});
		
		function get_values(id) {
			utab=$( '#table' ).val();
			$.ajax({
				cache: false, 
				url: '_getdbvalues.php?id='+id+'&tab='+utab,
				method: 'GET',
				success: function(r) {
					v=r.split(';');
					dialog(v);
				}
			});
		}

		function save_values() {
			uid=$( '#uid' ).val();
			utag=$( '#utag' ).val();
			uval=$( '#uval' ).val();
			utab=$( '#table' ).val();
			$.get("_savedbvalues.php", { id: uid, t: utag, v: uval, tab: utab },
				function(r){
					$('#form').submit();
			});
		}

		function insert_values() {
			utag=$( '#utag' ).val();
			uval=$( '#uval' ).val();
			utab=$( '#table' ).val();
			$.get("_insdbvalue.php", { t: utag, v: uval, tab: utab },
				function(r){
					$('#form').submit();
			});
		}

		function delete_values() {
			did=$( '#delid' ).val();
			utab=$( '#table' ).val();
			$.ajax({
				cache: false, 
				url: '_deldbvalue.php?id='+did+'&tab='+utab,
				method: 'GET',
				success: function(r) {
					$('#form').submit();
				}
			});
		}

		function delete_value(e) {
			utab=$( '#table' ).val();
			$.ajax({
				cache: false, 
				url: '_deldbvalue.php?id='+e+'&tab='+utab,
				method: 'GET',
				success: function(r) {
					$('#form').submit();
				}
			});
		}
		
		function dialog(v) {
			$( '#uid' ).val(v[0]);
			$( '#utag' ).val(v[1]);
			$( '#uval' ).val(v[2]);
			utab=$( '#table' ).val();
			$( '#gget' ).dialog({
				modal: true,
				minWidth: 500,
				title: 'Edit value in '+utab+' table',
				buttons: { 
					Ok: function() {
						save_values();
						$(this).dialog("close");
					},
					Close: function() {
						$(this).dialog("close");
					}
				}
			})
		}

		function dialog_new() {
			$( '#uid' ).val('-1');
			$( '#utag' ).val('');
			$( '#uval' ).val('');
			utab=$( '#table' ).val();
			$( '#gget' ).dialog({
				modal: true,
				minWidth: 500,
				title: 'Create New value in '+utab+' table',
				buttons: { 
					Ok: function() {
						insert_values();
						$(this).dialog("close");
					},
					Close: function() {
						$(this).dialog("close");
					}
				}
			})
		}

		function dialog_del() {
			$( '#uid' ).val('-1');
			utab=$( '#table' ).val();
			$( '#gdel' ).dialog({
				modal: true,
				minWidth: 350,
				title: 'Delete value form '+utab+' table',
				buttons: { 
					Ok: function() {
						delete_values();
						$(this).dialog("close");
					},
					Close: function() {
						$(this).dialog("close");
					}
				}
			})
		}
		
	});
</script>
</head>
<body>
<?php
	function detect_ie()
	{
		if (isset($_SERVER['HTTP_USER_AGENT']) && 
		(strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE') !== false))
			return true;
		else
			return false;
	}

$s=str_replace("*","%",$_POST['s0']);
if(isset($_POST['tab'])) {
	$table=$_POST['tab'];
} else {
	$table="config";	
}
if(isset($_POST['sort'])) { 
	$sort=$_POST['sort'];
} else {
	$sort="tag";
}
if(strlen($s)>0) {
	$where = " WHERE tag like '".$s."'";
	$query = "SELECT * FROM ".$table.$where."ORDER BY ".$sort;;
} else {
	$where = " WHERE tag like 'RÜLPS'";
	$query = "SELECT * FROM config".$where."ORDER BY ".$sort;;
}
$color = "#CCC";
$tablequery="SELECT name FROM sqlite_master WHERE type='table' ORDER BY name";
$tab=null;
$db= new PDO('sqlite:/etc/allnetenv/config.s3db', '', '');

if($table=="config") {
	$conf="selected=\"selected\" ";
	$front=NULL;
} else {
	$conf=NULL;
	$front="selected=\"selected\" ";
}
$tab ="<option ".$conf."value=\"config\">config</option>";
#$tab.="<option ".$front."value=\"frontend\">frontend</option>";

if(!detect_ie()) {
?>
<div style="margin-right: 20px;"><button id="unew">New Value</button><button id="udel">Delete Value</button><div style="float:right;"><button onclick="window.location.href=window.location+'default/';">Edit GenDefault</button><button onclick="window.location.href=window.location+'shell/';">SHELL</button></div></div><br /><br />
<?php } ?>
<form method="post" name="form" id="form">
Benutze * als Joker <?php if(!detect_ie()) { ?>// Doppelklick zum Editieren der Werte<?php } ?><br />
Tabelle:&nbsp;<select name="tab" id="tab"><?php echo $tab; ?></select>&nbsp;&nbsp;Tag:&nbsp; 
<input type="text" id="s0" name="s0" size="100px" value="<?php echo $_POST['s0']; ?>" /> 
<input type="submit" value="Abfragen" />
Sortierung:&nbsp;<select name="sort" id="sort">
	<option <?php if($sort=="id") { echo "selected=\"selected\""; } ?> value="id">id</option>
    <option <?php if($sort=="tag") { echo "selected=\"selected\""; } ?> value="tag">tag</option>
    <option <?php if($sort=="value") { echo "selected=\"selected\""; } ?> value="value">value</option>
</select>

</form>
<div id="gget" style="display:none">
<input type="hidden" id="uid" name="uid" value="">
<input type="hidden" id="table" name="table" value="<?php echo $table; ?>">
	Tag&nbsp;&nbsp;&nbsp;: <input id="utag" name="utag" size="50" value=""><br />
    Value&nbsp;:<input id="uval" name="uval" size="50" value=""><br />
</div>
<div id="gdel" style="display:none">
Delete Value ID&nbsp;:<input id="delid" name="delid" size="20" value=""><br />
</div>
<table border="1">
 <tr style="background-color: #ffe;">
   <td colspan="<?php if(isset($_GET['fast'])) { echo "4"; } else { echo "3"; } ?>">SQLite DBList [<?php echo $table; ?>]</td>
 </tr>
 <tr style="background-color: #ffe;">
   <td width="100px">Id</td><td width="400px">tag</td><td width="400px">value</td><?php if(isset($_GET['fast'])) { ?><td>&nbsp;</td><?php } ?>
 </tr>
<?php
foreach($db->query($query) as $r) {
?>
 <tr id="id<?php echo $r['id']; ?>" style="background-color: <?php echo $color; ?>">
   <td><?php echo $r['id']; ?></td>
   <td><?php echo $r['tag']; ?></td>
   <td><?php echo $r['value']; ?></td>
   <?php if(isset($_GET['fast'])) { ?>
	   <td><span id="<?php echo $r['id']; ?>" style="cursor:pointer;">***Delete***<span></td>
   <?php } ?>
  </tr>
<?php
if ($color == "#CCC") {
	$color = "#999";
} else { 
	$color = "#CCC";
}
}
?>
 
</table>
</body>
</html>