<?php 
   include "include/sqldb.php";
   $save_filename = "/data/tmp/headerkernelfs.bin";
   // Check that we have a file
   if((!empty($_FILES["file"])) && ($_FILES['file']['error'] == 0))
        {
   //Check if the file is JPEG image and it's size is less than 350Kb
   $filename = basename($_FILES['file']['name']);
   $ext = substr($filename, strrpos($filename, '.') + 1);
   if ($ext == "bin") {
      //Determine the path to which we want to save this file
      $newname = dirname(__FILE__).'/upload/'.$filename;
      //Check if the file with the same name is already exists on the server
      //Attempt to move the uploaded file to it's new place
      if ((move_uploaded_file($_FILES['file']['tmp_name'],$save_filename))) {
         // exec('/etc/init.d/upgrade_firmware');
         $file_length = filesize($save_filename);
######	//rframe_top("The file has been uploaded. File Size is " . $file_length . " Bytes");
         $header_data = "";
         $header_fields = 0;
         for($t = 0;$t < 100;$t++) {
            $header_name[$t] = "";
           $header_value[$t] = "";
         }
         $f = fopen($save_filename,"rb");
         $z ="x";
         $blbl = 0;
         $mcount = 0;
         do {
            $z = fread($f,1);
            if($z != ":") {
               if($blbl == 0) {
                  $header_name[$header_fields] = $header_name[$header_fields] . $z;
               }
            }
            if($z != "\n") {
               if($blbl == 1) {
                  $header_value[$header_fields] = $header_value[$header_fields] . $z;
               }
            }
            if($z != "\0") {
               $header_data = $header_data . $z;
            }
            $mcount = $mcount + 1;
            if($z == ":") {
               $blbl = 1;
               fread($f,1);
            }
            if($z == "\n") {
               $blbl = 0;
               $header_fields = $header_fields + 1;
            }
         } while (($z != "\0") && ($mcount < 10000));
         fclose($f);
         $model_installed_name = db_read("/sys/hardware/model");
         $model_installed_revision = db_read("/sys/hardware/revision");
         $fw_installed_version = db_read("/sys/firmware/version");
         $fw_installed_date = db_read("/sys/firmware/date");
         $fw_installed_versionnum = db_read("/sys/firmware/versionnum");
         $fw_installed_datenum = db_read("/sys/firmware/datenum");

         $model_read_name = "<unknown>";
         $model_read_revision = "<unknown>";
         $fw_read_version = "<unknown>";
         $fw_read_date = "<unknown>";
         $fw_read_versionnum = "<unknown>";
         $fw_read_datenum = "<unknown>";

         for($t = 0;$t < $header_fields;$t++) {
            if($header_name[$t] == "Model") $model_read_name = $header_value[$t];
            if($header_name[$t] == "Revision") $model_read_revision = $header_value[$t];
            if($header_name[$t] == "Firmware version") $fw_read_version = $header_value[$t];
            if($header_name[$t] == "Firmware release date") $fw_read_date = $header_value[$t];
            if($header_name[$t] == "FWVERSIONNUM") $fw_read_versionnum = $header_value[$t];
            if($header_name[$t] == "FWDATENUM") $fw_read_datenum = $header_value[$t];
         }

         if($model_read_name == "<unknown>") {
         // irgendein Mist wurde upgeloadet
            echo "{";
            echo "error: '***** ERROR *****',\n";
            echo "msg: 'The uploaded file is not a suitable firmware upload file. Please check if you did select the correct file.'\n";
            echo "}";  
         } else {
            // Header enth‰lt g¸ltige Daten, nun m¸ssen wir weiter pr¸fen
            if($model_read_name != $model_installed_name) {
               // FW ist f¸r ein anderes Ger‰t
               $msg ="The uploaded file is not a valid firmware file for this unit.";
               $msg.="You did upload a firmware file for an " . $model_read_name . ", but this device is an " . $model_installed_name . " !!!<br />";
                echo "{";
                echo "error: '***** ERROR *****',\n";
                echo "msg: '".$msg."'\n";
                echo "}";  
            } else {
               // Ger‰tebezeichnung stimmt, nun m¸ssen wir weiter pr¸fen
               if($model_read_version != $model_installed_version) {
                  // FW ist f¸r eine andere Board-Release
                  $msg ="The uploaded file is not a valid firmware file for this unit.";
                  $msg.="The uploaded firmware file is for board revision " . $model_read_revision . ", but his devisc has Board revision " . $model_installed_revision . " !!!<br />";
                  echo "{";
                  echo "error: '***** ERROR *****',\n";
                  echo "msg: '".$msg."'\n";
                  
                  echo "}"; 
               } else {
                  // Ger‰tebezeichnung und Boardrevision sind OK. Nun noch Datum und Version pr¸fen und ggfs. Warnhinweis ausgeben
                  $msg ="The uploaded file is a good and correct firmware upload file for an " . $model_read_name . ", Revision " . $model_read_revision . ".<br />";
                  $msg.="This is Firmware Version " . $fw_read_version . ", from " . $fw_read_date . ".<br /><br />";
                  $msg.="You are currently running Firmware Version " . $fw_installed_version . ", from " . $fw_installed_date . ".<br /><br />";
                  if($fw_installed_versionnum > $fw_read_versionnum) {
                     $msg.="Warning: The firmware you are trying to install is older than the currently running version !<br />";
                  }
                  if($fw_installed_versionnum == $fw_read_versionnum) {
                     $msg.="Warning: The firmware you are trying to install has the same version number as the currently running version !<br />";
                  }
                  $msg.="If you are absolutely sure you want to write the contents of the firmware image file that you uploaded to the system¥s FLASH memory, then please click the Link below:<br /><br />";
                  $msg.="<A HREF=\"fw_writeflash.php\">WRITE TO FLASH</A><br /><br />";
                  $msg.="Please note, that overwriting the FLASH memory is a critical process. This will take approx. 2 - 3 minutes. During this ";
                  $msg.="time, it is absolutely important that the device can work without disturbance, and power is not interrupted. A failure here can ";
                  $msg.="make your device non-bootable and useless. Please be careful !<br />";
                  echo "{";
                  echo "error: 'Upload OK !',\n";
                  echo "msg: '".$msg."'\n";
                  echo "}"; 
               }
            }
         }
      } else {
         $msg = "A problem occurred during file upload!";
         echo "{";
         echo "error: 'Error',\n";
         echo "msg: '".$msg."'\n";
         echo "}"; 
      }
   } else {
      $msg = "Only .bin images are accepted for upload";
      echo "{";
      echo "error: 'Error',\n";
      echo "msg: '".$msg."'\n";
      echo "}";
   }
} else {
   $msg = "No file uploaded";
   echo "{";
   echo "error: 'Error',\n";
   echo "msg: '".$msg."'\n";
   echo "}";
}
?>